=== kernel/snapshots/linux-2.5.31/drivers/block/Makefile ===
CCOPTS = -D__KERNEL__ -DMODULE -I../../include -I/usr/local/src/linux-2.5.12/include -O2 

enbd.o: enbd.c
	$(CC) $(CCOPTS) -c $^ -o $@
