=== kernel/snapshots/linux-2.5.64/drivers/block/enbd/Makefile ===
#
# Makefile for ENBD (Peter T. Breuer ptb@it.uc3m.es)
#
#

obj-$(CONFIG_BLK_DEV_ENBD)		+= enbd.o
obj-$(CONFIG_BLK_DEV_ENBD_IOCTL)	+= enbd_ioctl.o

enbd-objs := enbd_base.o enbd_ioctl_stub.o enbd_seqno.o enbd_md.o enbd_speed.o enbd_proc.o
