=== debian/changelog ===
enbd (2.4.31-20040412-1) unstable; urgency=low

  * upgrade client device special file detection logic to fallback to use any
    major+minor block device in the directory that is usable for the
    subchannels.  (Maybe) this allows use of the kernel nbd naming scheme.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 12 Apr 2004 12:17:41 +0100

enbd (2.4.31-20040411-1) unstable; urgency=low

  * support compile for UML with ARCH=um
  * rearranged debian scripts to cure install noise
    formally closes #201551 (noisy postinstall and prerem).
  * formally closes #215499 (/etc/services not modified for ages now).
  * formally closes #232818 (bad _IO declaration in various *.c fixed ages ago).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sun, 11 Apr 2004 12:17:41 +0100

enbd (2.4.31-20040410-1) unstable; urgency=low

  * fix compile under debian testing with 2.6 sources, hopefully
       (closes #239835).
  * add 2.6.3 kernel patch

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sat, 10 Apr 2004 17:17:41 +0100

enbd (2.4.31-20040215-1) unstable; urgency=low

  * fix userspace _IO for 2.6.1 patch (closes #232818 before it opened)

 -- Peter T. Breuer <ptb@it.uc3m.es>  Sun, 15 Feb 2004 12:45:01 +0200

enbd (2.4.31-20031217-1) unstable; urgency=low

  * fix init.d/enbd script bug (left over debugging?).
  * edit debian/kpatch type stuff to tell it about more kernel patches.
  * minor fix to hash (init size calc) carried over from late 2.4.31
  * make server generate consistent random sig per hostnode and resource.
  * allow server to start even if can't make pidfile, allowing nonroot

 -- Peter T. Breuer <ptb@it.uc3m.es>  Wed, 17 Dec 2003 15:45:51 +0200

enbd (2.4.31-20031024-1) unstable; urgency=low

  * fix compile under libc5 via more autconf and fallback stuff.
  * somehow remove or workaround driver reference counting bug making
    it not notice that all clients have died and thus disable itself
    in that case (shows up with show_errs=1). This bug may come back
    if one uses partitions because (a) I'm not sure how I cleared it and
    (b) I cleared it only certainly in the case when there are no
    partitions, by introducing a fallback last-ditch reference counting
    method.  That method will be fooled if the subdevices are mounted
    and hence have one more reference count than the daemon alone.
    Anyway, the subdevices now have reference counters.
  * bump version number.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Fri, 24 Oct 2003 15:45:51 +0200

enbd (2.4.31-20030924-1) unstable; urgency=low

  * Allow enbd-test to work on files and dirs, not just devs.
  * Use spinlocks on slot to fix old clear/ack race in driver.
  * Make slot accounting counters atomic types, just in case.
  * Make 2.4.22 patch (closes #214497).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Wed, 24 Sep 2003 18:10:33 +0200

enbd (2.4.31-20030911-1) unstable; urgency=low

  * Wrap gettimeofday against negative system time jumps.
  * Remove more remnants of builtin raid1 from driver.
  * Fix compile on ia64 (closes #205317).
  * Include MAKEDEV call in postinst (closes #209356)

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 11 Sep 2003 18:10:33 +0200

enbd (2.4.31-20030821-1) unstable; urgency=high

  * Heisenbug somewhere in enbd-client server_write() probably fixed.
  * Seek tests from Arne Wiebalck incorporated in enbd-test (-r too).
  * Minor Makefile fixes.
  * Fix nasty bug in init_module() in enbd_raw.c. Destructive one.
  * enbd-test.8 man page extended and updated (Arne Wiebalck).

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 21 Aug 2003 18:10:33 +0200

enbd (2.4.31-20030818-1) unstable; urgency=low

  * Separate binary-arch and binary-arch-indep deb builds.
    (Closes: Bug#205156).
  * Used ENBD_ prefix for all macros, instead of NBD_. Ditto enbd_
    instead of nbd_ for function names and structs.
  * Made enbd_raw.o module.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 18 Aug 2003 08:21:10 +0200

enbd (2.4.31-20030807-1) unstable; urgency=low

  * Rip out builtin raid1 support in favour of fr1 interface.
  * #ifdef use of raw interface.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 7 Aug 2003 12:26:13 +0200

enbd (2.4.31-20030717-1) unstable; urgency=low

  * Fix excess noise in init and postrm (closes: Bug#201551)
  * Add -h switch to server to control result cache size
  * Add lo/hi water marks to result cache
  * Move shrink cache down into result cache itself
  * Toughen microselect against ENOMEM from select

 -- Peter T. Breuer <ptb@it.uc3m.es>  Thu, 17 Jul 2003 16:09:01 +0200

enbd (2.4.31-20030623-1.1) unstable; urgency=low

  * NMU
  * debian/control :
    - Build-Depends (and not Build-Depends-Indep) on dh-kpatches
      (Closes: #200808).
    - Fix copyright-lists-upstream-authors-with-dh_make-boilerplate
      lintian warning in kernel-patch-enbd package.
    - Fix description-synopsis-might-not-be-phrased-properly lintian
      warning in kernel-patch-enbd package.
  * debian/rules :
    - Stop invoking dh_testversion as it's deprecated and the package
      is already using versioned dependencies on debhelper in its
      Build-Depends.

 -- Andre Luis Lopes <andrelop@debian.org>  Sat, 19 Jul 2003 22:16:15 -0300

enbd (2.4.31-20030623-1) unstable; urgency=low

  * Fix __BIG_ENDIAN misspelling (closes: Bug#198448)
  * Fix semaphore deadlock in callback from md_notify (raid, fr1)
  * Simplify md (fr1) ioctls
  * Add partition support in md (fr1) ioctls.
  * Set show_errors while remote_invalid asserted; more intuitive.
  * Make setting signature require a little more magic.
  * Add silly raw (iovec) and serial transfer modes - to go away again!
  * Fix typos (*->&, & -> &&) in FSYNC treatement in server.
  * Add FCNTL locking option in locking module.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Mon, 23 Jun 2003 03:49:02 +0200

enbd (2.4.31-20030506-1) unstable; urgency=low

  * Use fcntl instead of atomic kernel ops in lock.c. For portability.

 -- Peter T. Breuer <ptb@it.uc3m.es>  Tue, 6 May 2003 12:18:22 +0200


