=== debian/control ===
Source: enbd
Section: net
Priority: optional
Maintainer: Peter T. Breuer <ptb@it.uc3m.es>
Standards-Version: 3.5.10
Build-Depends: debhelper (>> 3.0.0), dh-kpatches

Package: enbd
Architecture: any
Depends: ${shlibs:Depends}
Suggests: kernel-patch-enbd
Description: Enhanced Network Block Device support
 This is a client/server package supporting the enbd kernel module.
 Enbd-client proxies kernel requests, passing them across the net to a
 remote enbd-server daemon. In conjunction with the kernel module to
 which the client talks, this makes the remote resource on the server
 appear as a local block device.  NBDs may be treated like any other
 block device.  In particular, they may have file systems made on them
 and then may be mounted into the local file system tree.  This package
 contains the userland support daemons for the Enhanced NBD kernel
 driver.
 .
 Regular updates will be found at
 ftp://oboe.it.uc3m.es/pub/Programs/, and the project web page is at
 http://www.it.uc3m.es/ptb/enbd/. Go to www.freshmeat.net and look up
 "ENBD" for more recent public release announcements.

Package: kernel-patch-enbd
Architecture: all
Depends: ${kpatch:Depends}
Suggests: kernel-source, kernel-package, enbd
Description: Enhanced Network Block Device support kernel patch
 This is the kernel patch required by the enbd-client from the enbd
 package.
 .
 Regular updates to this patch will be found at
 ftp://oboe.it.uc3m.es/pub/Programs/, and the project web page is at
 http://www.it.uc3m.es/ptb/enbd/.  Go to www.freshmeat.net and look up
 "ENBD" for more recent public release announcements.
